package people;


public class TestStudent extends AbstractTest {

	public static void main(String[] args) throws InstantiationException, IllegalAccessException {
		new TestStudent();
	}

	protected void runTests() {
		this.testExpected = 25;		
		try {
			testSuperTypes();
		} catch (Exception e) { e.printStackTrace(); /*this.testFailed++;*/}
		try {
			testGetAndSetGrade();
		} catch (Exception e) { e.printStackTrace(); /*this.testFailed++;*/}
		try {
			testGetUniqueId();
		} catch (Exception e) { e.printStackTrace(); /*this.testFailed++;*/}
		try {
			testToString();
		} catch (Exception e) { e.printStackTrace(); /*this.testFailed++;*/}
		try {
			testCopyConstructor();
		} catch (Exception e) { e.printStackTrace(); /*this.testFailed++;*/}
		try {
			testEquals();
		} catch (Exception e) { e.printStackTrace(); /*this.testFailed++;*/}
		// we might test a StudentImpl by running TestPersonImpl
	}

	public void testSuperTypes() {
		StudentImpl p = new StudentImpl("ESIAL2012", "Anakin", 19, Student.YEAR_1ST);
		assertInstanceOf(p, people.Student.class);
		assertInstanceOf(p, people.Person.class);
		assertInstanceOf(p, people.PersonImpl.class);
	}

	public void testGetAndSetGrade() {
		StudentImpl p = new StudentImpl("ESIAL2012", "Anakin", 19, Student.YEAR_1ST);

		double expected = Student.YEAR_1ST;
		double value = p.getGrade();
		assertEquals(expected, value);

		p.setGrade(Student.YEAR_2ND);
		expected = Student.YEAR_2ND;
		value = p.getGrade();
		assertEquals(expected, value);

		p.setGrade(Student.YEAR_3RD);
		expected = Student.YEAR_3RD;
		value = p.getGrade();
		assertEquals(expected, value);
	}

	public void testGetUniqueId() {
		StudentImpl p = new StudentImpl("ESIAL2012", "Anakin", 19, Student.YEAR_1ST);
		assertEquals("ESIAL2012", p.getUniqueId());
	}

	public void testToString() {
		StudentImpl p = new StudentImpl("ESIAL2012", "Anakin", 19, Student.YEAR_1ST);

		String expectedS = "[ESIAL2012] Anakin (age: 19) grade: 1A";
		String valueS = p.toString();
		assertEquals(expectedS, valueS);
	}

	public void testCopyConstructor() {
		StudentImpl p = new StudentImpl("ESIAL2012", "Anakin", 19, Student.YEAR_1ST);
		StudentImpl copy = new StudentImpl(p);

		assertTrue(p != copy, "references should not be equal");
		assertEquals(p.getName(), copy.getName());
		assertEquals(p.getAge(), copy.getAge());
		assertEquals(p.getGrade(), copy.getGrade());
		assertEquals(p.getUniqueId(), copy.getUniqueId());
	}

	public void testEquals() {
		Student p = new StudentImpl("ESIAL2012", "Anakin", 19, Student.YEAR_1ST);
		Student p2 = new StudentImpl("ESIAL2012", "Anakin", 19, Student.YEAR_1ST);
		Student pDifferentName = new StudentImpl("ESIAL2012", "Luke", 19, Student.YEAR_1ST);
		Student pDifferentAge = new StudentImpl("ESIAL2012", "Anakin", 21, Student.YEAR_1ST);
		Student pDifferentId = new StudentImpl("ESSTIN2012", "Anakin", 19, Student.YEAR_1ST);
		Student pDifferentGrade = new StudentImpl("ESIAL2012", "Anakin", 19, Student.YEAR_2ND);
		Student pNullId = new StudentImpl(null, "Anakin", 19, Student.YEAR_1ST);
		Student pNullName = new StudentImpl("ESIAL2012", null, 19, Student.YEAR_1ST);

		assertTrue(!p.equals(new Object()), "objects should not be equal");
		assertTrue(p.equals(p), "object should be equal to itself");
		assertTrue(p.equals(p2), "objects should be equal");
		assertTrue(!p.equals(pDifferentName), "objects should not be equal");
		assertTrue(!p.equals(pDifferentAge), "objects should not be equal");
		assertTrue(!p.equals(pDifferentId), "objects should not be equal");
		assertTrue(!p.equals(pDifferentGrade), "objects should not be equal");
		assertTrue(!p.equals(null), "object should not be equal to null reference");
		assertTrue(!p.equals(pNullId), "objects should not be equal");
		assertTrue(!p.equals(pNullName), "objects should not be equal");
		assertTrue(!pNullId.equals(p), "objects should not be equal");
		assertTrue(!pNullName.equals(p), "objects should not be equal");
	}

}
